Subject: Re: bug#73404: 30.0.50; [forward/kill/etc]-sexp commands do not behave as expected in tree-sitter modes

From: Yuan Fu <[email-masked]>
Date: Mon, 6 Jan 2025 10:04:24 -0800

>> 
>> I think these should be oblivious to the syntax (i.e. line `forward-line`
>> and `forward-char`).
>> 
>> Your list missed the "defun" unit of navigation.
> 
> Because there is no `forward-defun` ;-)
> 
> But strange that "defun" still is defined by `treesit-defun-type-regexp`
> instead of a "defun" thing in `treesit-thing-settings`.

treesit-defun-type-regexp is shipped in Emacs 29, so we can’t just remove it. Defun navigation functions in treesit.el does support the defun thing, but I made treesit-defun-type-regexp an override of the defun thing. OTOH treesit-sexp/sentence-type-regexp wasn’t shipped in Emacs 29 so I removed them, preferring the thing definition.

Yuan